% Aufgabe1, Blatt 2
% Karsten Wolke, Helge Janicke
% load familie.pl first.

% copy from familie.pl
% ----------------------------------------------------------
% Prozedur: 	elternteil(X,Y) 
% Parameter: 	X, Y sind Personen
% Bedeutung:	elternteil(X,Y) ist wahr, wenn X Elternteil 
%		von Y ist. 
% ----------------------------------------------------------
elternteil(thomas,robert).
elternteil(heike,robert).
elternteil(thomas,lisa).
elternteil(robert,anna).
elternteil(robert,petra).
elternteil(petra,jakob).
%new
elternteil(lisa, marina).

% ----------------------------------------------------------
% Prozedur: 	maennlich(X) 
% Parameter: 	X ist eine Person
% Bedeutung:	maennlich(X) ist wahr, wenn X ein Mann ist. 
% ----------------------------------------------------------
maennlich(thomas).
maennlich(robert).
maennlich(jakob).
%new
maennlich(markus).
maennlich(klaus).

% ----------------------------------------------------------
% Prozedur: 	weiblich(X) 
% Parameter: 	X ist eine Person
% Bedeutung:	weiblich(X) ist wahr, wenn X eine Frau ist. 
% ----------------------------------------------------------
weiblich(petra).
weiblich(heike).
weiblich(lisa).
weiblich(anna).
%new
weiblich(marina).

% ----------------------------------------------------------
% Prozedur: 	mutter(M,K) 
% Parameter: 	M, K sind Personen
% Bedeutung:	mutter(M,K) ist wahr, wenn M Mutter von K ist.. 
% ----------------------------------------------------------
mutter(M,K) :-
	elternteil(M,K),
	weiblich(M).
	
% ----------------------------------------------------------
% Prozedur: 	verheiratet(X,Y) 
% Parameter: 	X und Y sind Personen; X ist eine Frau, Y ein Mann
% Bedeutung:	verheiratet(X,Y) ist wahr, wenn X 
%		und Y verheiratet sind. 
% ----------------------------------------------------------
verheiratet(heike,thomas).
verheiratet(petra,markus).
% new 
verheiratet(lisa,klaus).
verheiratet(max, moritze).
verheiratet(haensel, gretel).
	
% ----------------------------------------------------------
% Prozedur: 	verheiratet_mit(X,Y) 
% Parameter: 	X und Y sind Personen
% Bedeutung:	verheiratet(X,Y) ist wahr, wenn X 
%		und Y verheiratet sind. 
% ----------------------------------------------------------
%Fall 1: X ist Frau, Y ist Mann
verheiratet_mit(X,Y) :-
	verheiratet(X,Y).
%Fall 2: X ist Mann, Y ist Frau
verheiratet_mit(X,Y) :-
	verheiratet(Y,X).
	
	
% Struktur: 	datum(T,M,J) 
% Parameter: 	T ist ein Tag (1,..,31)
%		M ist ein Monat (1,2,...,12)
%		J ist ein Jahr (1900,...,2002)	
	
% Prozedur: 	geboren(P,D) 
% Parameter: 	P ist eine Person, 
%		D ist ein Datum 
% Bedeutung:	geboren(P,D) ist wahr, wenn P zum Datum D 
%		geboren ist. 
geboren(thomas,datum(5,8,1928)).
geboren(heike,datum(6,2,1934)).
geboren(lisa,datum(1,4,1951)).
geboren(robert,datum(9,11,1951)).
geboren(anna,datum(5,8,1980)).
geboren(petra,datum(5,8,1980)).
geboren(jakob,datum(12,7,2001)).
% end of copy





% ----------------------------------------------------------
% Prozedur: 	vater(V,K) 
% Parameter: 	V, K sind Personen
% Bedeutung:	vater(V,K) ist wahr, wenn V Vater von K ist.. 
% ----------------------------------------------------------
vater(V,K) :-
	elternteil(V,K),
	maennlich(V).
 

% PROZEDUR:		grossvater(G,E)
% PARAMETER:	G, E sind Personen; 
% BEDEUTUNG:	ist wahr wenn G Grossvater von E ist.
grossvater(G,E) :-
	elternteil(X,E),
	vater(G,X).

% PROZEDUR:		grosseltern(G,E)
% PARAMETER:	G, E sind Personen; 
% BEDEUTUNG:	ist wahr wenn G Grosselternteil von E ist.
grosseltern(G,E) :-
	elternteil(X,E),
	elternteil(G,X).
	
% PROZEDUR:		cousine(X,Y)
% PARAMETER:	X, Y sind Personen; 
% BEDEUTUNG:	ist wahr wenn X cousine von Y ist.
cousine(X,Y) :-
	weiblich(X),
	grosseltern(G,X),
	grosseltern(G,Y),
	\+ geschwister(X,Y),
	X \== Y.
	
% PROZEDUR:		geschwister(X,Y)
% PARAMETER:	X, Y sind Personen; 
% BEDEUTUNG:	ist wahr wenn X Geschwister von Y ist.
geschwister(X,Y) :-
	elternteil(E,X),
	elternteil(E,Y),
	X \== Y.
		
% PROZEDUR:		schwager(X,Y)
% PARAMETER:	X, Y sind Personen; 
% BEDEUTUNG:	ist wahr wenn X Schwager von Y ist.
schwager(X,Y) :-
	geschwister(G,Y),
	verheiratet_mit(G,X),
	maennlich(X).

schwager(X,Y) :-
	verheiratet_mit(Y,P),
	geschwister(P,X),
	maennlich(X).
	

