% 
% Datei: familie.pl
% =================
%
% ----------------------------------------------------------
% Prozedur: 	elternteil(X,Y) 
% Parameter: 	X, Y sind Personen
% Bedeutung:	elternteil(X,Y) ist wahr, wenn X Elternteil 
%		von Y ist. 
% ----------------------------------------------------------
elternteil(thomas,robert).
elternteil(heike,robert).
elternteil(thomas,lisa).
elternteil(robert,anna).
elternteil(robert,petra).
elternteil(petra,jakob).

% ----------------------------------------------------------
% Prozedur: 	maennlich(X) 
% Parameter: 	X ist eine Person
% Bedeutung:	maennlich(X) ist wahr, wenn X ein Mann ist. 
% ----------------------------------------------------------
maennlich(thomas).
maennlich(robert).
maennlich(jakob).

% ----------------------------------------------------------
% Prozedur: 	weiblich(X) 
% Parameter: 	X ist eine Person
% Bedeutung:	weiblich(X) ist wahr, wenn X eine Frau ist. 
% ----------------------------------------------------------
weiblich(petra).
weiblich(heike).
weiblich(lisa).
weiblich(anna).

% ----------------------------------------------------------
% Prozedur: 	mutter(M,K) 
% Parameter: 	M, K sind Personen
% Bedeutung:	mutter(M,K) ist wahr, wenn M Mutter von K ist.. 
% ----------------------------------------------------------
mutter(M,K) :-
	elternteil(M,K),
	weiblich(M).
	
% ----------------------------------------------------------
% Prozedur: 	verheiratet(X,Y) 
% Parameter: 	X und Y sind Personen; X ist eine Frau, Y ein Mann
% Bedeutung:	verheiratet(X,Y) ist wahr, wenn X 
%		und Y verheiratet sind. 
% ----------------------------------------------------------
verheiratet(heike,thomas).
verheiratet(petra,markus).
	
% ----------------------------------------------------------
% Prozedur: 	verheiratet_mit(X,Y) 
% Parameter: 	X und Y sind Personen
% Bedeutung:	verheiratet(X,Y) ist wahr, wenn X 
%		und Y verheiratet sind. 
% ----------------------------------------------------------
%Fall 1: X ist Frau, Y ist Mann
verheiratet_mit(X,Y) :-
	verheiratet(X,Y).
%Fall 2: X ist Mann, Y ist Frau
verheiratet_mit(X,Y) :-
	verheiratet(Y,X).
	
% ----------------------------------------------------------
% Prozedur: 	vorfahr(X,Y) 
% Parameter: 	X und Y sind Personen
% Bedeutung:	vorfahr(X,Y) ist wahr, wenn X Vorfahr von Y ist. 
% ----------------------------------------------------------
%Fall 1: direkter Vorfahr
vorfahr(X,Y) :-
	elternteil(X,Y).
% Fall 2: mittelbarer Vorfahr (rekursive Def.)
vorfahr(X,Y) :-
	elternteil(X,Z),
	vorfahr(Z,Y).	
	

% Struktur: 	datum(T,M,J) 
% Parameter: 	T ist ein Tag (1,..,31)
%		M ist ein Monat (1,2,...,12)
%		J ist ein Jahr (1900,...,2002)	
	
% Prozedur: 	geboren(P,D) 
% Parameter: 	P ist eine Person, 
%		D ist ein Datum 
% Bedeutung:	geboren(P,D) ist wahr, wenn P zum Datum D 
%		geboren ist. 
geboren(thomas,datum(5,8,1928)).
geboren(heike,datum(6,2,1934)).
geboren(lisa,datum(1,4,1951)).
geboren(robert,datum(9,11,1951)).
geboren(anna,datum(5,8,1980)).
geboren(petra,datum(5,8,1980)).
geboren(jakob,datum(12,7,2001)).

	
	
	
	
