% Aufgabe 2, Blatt 3
% Karsten Wolke, Helge Janicke

% Struktur: pt(X,Y) 
% Komponenten: X und Y sind Zahlen 
% Bedeutung: pt(X,Y) stellt den Punkt (X,Y) dar.

% Struktur: 	kreis(M, R)
% Komponenten: 	M der Kreismittelpunkt, ein pt.
%				R ist der Kreisradius ( >= 0 ).

% Struktur: rec(P0,P1) 
% Komponenten: P0 und P1 sind pt(s) 
% Bedeutung: rec(P0,P1) stellt ein Rechteck mit dar.
%			 P0 ... obere linke Ecke.
%			 P1 ... untere rechte Ecke.


% Prozedur: distanz(P,Q,D) 
% Parameter: P und Q sind Punkte (vom Typ pt(X,Y)), D ist eine Zahl 
% Bedeutung: wahr, wenn D die euklidische Distanz 
% 			 zwischen den Punkten P und Q ist
distanz(P,Q,D) :- 
	P = pt(X1,Y1), 
	Q = pt(X2,Y2), 
	D is sqrt((X1-X2)^2 + (Y1-Y2)^2).
	
% Prozedur: 	punkt_in_kreis(P, K) 
% Parameter:    P ist ein Punkt,  K ist ein kreis.
% Bedeutung:	ist wahr wenn P in K liegt.
punkt_in_kreis(P, K) :-
	K = kreis(M,R),
	distanz(P,M,D),
	D =< R.
	
% punkt_in_kreis(pt(3,3),kreis(pt(0,0),2)).
% punkt_in_kreis(pt(3,3),kreis(pt(0,0),5)).

% Prozedur: 	kreis_flaeche(K, F) 
% Parameter:    K ist ein kreis. F ist eine Zahl
% Bedeutung:	ist wahr wenn F die Flche des Kreises K ist.
kreis_flaeche(K, F) :-
	K = kreis(_,R),
	F is pi * R^2.

% kreis_flaeche(kreis(pt(0,0),1),F).

% Prozedur:     kreis_um_rec(R,K)
% Parameter:    R ist ein rec, K ist ein kreis.
% Bedeutung:	ist wahr wenn K der umschliessende Kreis um das 
% 				Rechteck R ist.
kreis_um_rec(rec(P0,P1),K) :-
	P0 = pt(X0,Y0),
	P1 = pt(X1,Y1),
	Mx is X0 + (X1-X0) / 2,
	My is Y0 + (Y1-Y0) / 2,
	M = pt(Mx,My),
	distanz(M, P0, R),
	K = kreis(M,R).

% kreis_um_rec(rec(pt(0,1),pt(1,0)),K).
% K = kreis(pt(0.5, 0.5), 0.707107)

