% Aufgabe 3, Blatt 3
% Karsten Wolke, Helge Janicke

% Zeitlich sortiert von frh nach spt !!!!
% PROZEDUR:		ankunft(Bhf,Z)
% PARAMETER:	Bhf ist ein Bahnhof, Z ist eine Zeit. 
% BEDEUTUNG:	wahr wenn der Zug kommt um Z am Bahnhof Bhf an.
%				( ;o) p(ankunft(Bhf,Z)) --> 0 )
ankunft(braunschweig,zeit(20:34)). 
ankunft(magdeburg,   zeit(21:11)). 
ankunft(potsdam,     zeit(22:40)). 
ankunft(berlin,      zeit(23:10)). 

% Zeitlich sortiert von frh nach spt !!!!
% PROZEDUR:		abfahrt(Bhf,Z)
% PARAMETER:	Bhf ist ein Bahnhof, Z ist eine Zeit. 
% BEDEUTUNG:	wahr wenn der Zug um Z am Bahnhof Bhf abfhrt.
abfahrt(braunschweig,zeit(20:38)). 
abfahrt(magdeburg,   zeit(21:16)). 
abfahrt(potsdam,     zeit(22:45)). 
abfahrt(berlin,      zeit(23:18)).


% PROZEDUR:	    ist_spaeter_als(Z2,Z1)
% PARAMETER:	Z2, Z1 sind zeit(en)
% BEDEUTUNG:	wahr wenn Z2 spter als Z1 (no daybreak)
ist_spaeter_als(zeit(H2:M2), zeit(H1:M1)) :-
	(H2 > H1); (H2 =:= H1, M2 > M1).

% PROZEDUR:	 naechste_ankunft(AktuelleZeit, AnkunftZeit, Naechster_BHF)
% PARAMETER: AktuelleZeit, AnkunftZeit sind zeit(en)
%            Naechster_BHF ist ein Bahnhof.
% BEDEUTUNG: wahr wenn AnkunftZeit die nchste Zeit spter als
% 			 AktuelleZeit und der Zug zur Ankunftzeit im 
%			 Naechster_Bahnhof einfhrt.
naechste_ankunft(AktuelleZeit, AnkunftZeit, Naechster_BHF) :-
	ankunft(Naechster_BHF, Zeit),
	ist_spaeter_als(Zeit, AktuelleZeit),
	AnkunftZeit = Zeit,
	!.
	

% PROZEDUR:	    zeit_diff(Z2,Z1, D)
% PARAMETER:	Z2, Z1 sind zeit(en), D sind Minuten.
% BEDEUTUNG:	wahr wenn zwischen Z1 und Z2 D Minuten liegen.
zeit_diff(zeit(H1:M1),zeit(H2:M2), D) :-
	D is H2*60 + M2 - (H1*60 + M1).
	
	
% PROZEDUR:	    fahrzeit(StartBHF, EndBHF, Zeit)
% PARAMETER:	StartBHF, EndBHF sind Bahnhfe
%				Zeit ist eine zeit.
% BEDEUTUNG:	wahr wenn Zeit die Fahrzeit zwischen StartBHF und EndBHF
%				ist.
fahrzeit(StartBHF, EndBHF, Zeit) :-
	abfahrt(StartBHF, StartZeit),
	fahrzeit_rec(StartZeit, 0, EndBHF, MinZeit),
	Stunden is MinZeit // 60,
	Minuten is MinZeit mod 60,
	Zeit = zeit(Stunden:Minuten).
	
	
% PROZEDUR:	    fahrzeit_rec(LetzteAb, SumZeit, EndBHF, Ergebnis)
% PARAMETER:	LetzteAb ist eine zeit.
%				SumZeit, Ergebnis sind Minuten
%			 	EndBHF ist Bahnhof
% BEDEUTUNG:	wahr wenn das Ergebnis gleich der SumZeit + der Fahrzeit 
%           	zwischen dem Bahnhof, der bei LetzteZeit verlassen wurde
%				und dem EndBhf ist.
fahrzeit_rec(LetzteAb, SumZeit, EndBHF, Ergebnis) :-
	naechste_ankunft(LetzteAb, AnkunftZeit, NaechsterBHF),
	NaechsterBHF = EndBHF,
	zeit_diff(LetzteAb, AnkunftZeit, D),
	Ergebnis is SumZeit + D.

fahrzeit_rec(LetzteAb, SumZeit, EndBHF, Ergebnis) :-
	naechste_ankunft(LetzteAb, AnkunftZeit, NaechsterBHF),
	NaechsterBHF \== EndBHF,
	zeit_diff(LetzteAb, AnkunftZeit, D),
	SumZeitNeu is SumZeit + D,
	abfahrt(NaechsterBHF, AbfahrtZeit),
	fahrzeit_rec(AbfahrtZeit, SumZeitNeu, EndBHF, Ergebnis).	
		 
