% Aufgabe 3, Blatt 4
% Karsten Wolke, Helge Janicke

% copied from affe.pl
%

hp(tuer).
hp(fenster).
hp(mitte).

% Struktur: 	zustand(HP,VP,HP,B) 
% Komponenten: 	HP ist eine horizontale Position 
%		(tuer, mitte, fenster)
%		VP ist eine vertikale Position(boden, kiste)
%		B bedeutet: Affe hat die Banane (ja, nein)

% ----------------------------------------------------------
% Prozedur: 	start(Z) 
% Parameter: 	Z ist ein Zustand
% Bedeutung:	Z ist Startzustand
% ----------------------------------------------------------
start(zustand(tuer,boden,fenster,nein)). 

% ----------------------------------------------------------
% Prozedur: 	ziel(Z) 
% Parameter: 	Z ist ein Zustand
% Bedeutung:	Z ist Zielzustand
% ----------------------------------------------------------
ziel(zustand(_,_,_,ja)). 

% ----------------------------------------------------------
% Prozedur: 	aktion(Z1,A,Z2) 
% Parameter: 	Z1 und Z2 sind Zustnde;
%		A ist eine Aktion (holt, klettert, 
%		schiebt(P1,P2), geht(P1,P2)
% Bedeutung:	aktion(Z1,A,Z2) ist wahr, wenn Aktion A in Z1
% 		ausfhrbar ist, und wenn anschlieend Z2 gilt.
% ----------------------------------------------------------
% Der Affe holt die Banane
aktion(zustand(mitte,kiste,mitte,_), holt, zustand(mitte,kiste,mitte,ja)).

% Der Affe klettert auf die Kiste. 
aktion(zustand(X,boden,X,Y), klettert, zustand(X,kiste,X,Y)).

% Der Affe schiebt die Kiste von P1 nach P2
aktion(zustand(HPA,boden,HPA,Y), schiebt, zustand(HPANeu,boden,HPANeu,Y)) :-
	hp(HPNeu),
	HPNeu \== HPA.

% Der Affe luft von P1 nach P2
aktion(zustand(HPA,boden,X,Y), geht, zustand(HPANeu,boden,X,Y)) :-
	hp(HPANeu),
	HPANeu \== HPA.



% ----------------------------------------------------------
% Prozedur: 	erreicht(Z1,Z2) 
% Parameter: 	Z1 und Z2 sind Zustnde;
% Bedeutung:	erreicht(Z1,Z2) ist wahr, wenn der Affe von 
% 		Zustand Z1 aus mit einer Folge von Aktionen 
%		Z2 erreichen kann.
% ----------------------------------------------------------
% Fall 1: Mit einer Aktion von Z1 nach Z2:
erreicht(Z1,Z2,[(Aktion)]) :-
	aktion(Z1,Aktion,Z2).
%	format('von ~p nach ~p mit Aktion ~p ~n',[Z1,Z2,Aktion]).
% Fall 2: Mit mehreren Aktionen:
erreicht(Z1,Z2, [(Aktion,HPA,HPANeu)|Rest]) :-
	aktion(Z1,Aktion,Z),
	Z1 = zustand(HPA,_,_,_),
	Z  = zustand(HPANeu,_,_,_),
	erreicht(Z,Z2,Rest).
%	format('von ~p nach ~p mit Aktion ~p ~n',[Z1,Z2,Aktion]).

% ----------------------------------------------------------
% Prozedur: 	affe_banane 
% Parameter: 	---
% Bedeutung:	affe_banane ist wahr, wenn der Affe die Banane kriegt
% ----------------------------------------------------------	
affe_banane(Aktionen) :-
	start(Start),
	ziel(Ziel),
	erreicht(Start,Ziel,Aktionen).

	

