% Aufgabe1, Blatt 5
% Karsten Wolke, Helge Janicke

% PROZEDUR:		menge(L, M)
% PARAMETER:	L ist eine Liste
%				M ist eine Menge
% BEDEUTUNG:	ist wahr wenn M die aufsteigend sortierte Menge 
%				bestehend aus den Elementen von L ist.
menge(L,M) :-
	setof(X,member(X,L),M).

% menge([1,2,3,3,3,4,2,0],M).
% M = [0, 1, 2, 3, 4] ;

	
% PROZEDUR:		schnitt(M1, M2, S)
% PARAMETER:	M1, M2, S sind Mengen
% BEDEUTUNG:	ist wahr wenn S die Schnittmenge von M1, M2 ist.
%				Alle (x element M1 | x element M2). 
schnitt(M1,M2,S) :-
	setof(X,(member(X, M1), member(X, M2)), S).

% schnitt([1,2,3,4,5],[3,4,7,8],S).
% S = [3, 4] ;

		
% PROZEDUR:		vereinigung(M1, M2, S)
% PARAMETER:	M1, M2, S sind Mengen
% BEDEUTUNG:	ist wahr wenn S die Vereinigungsmenge von M1, M2 ist.
%				Alle (x element M1 oder x element M2). 
vereinigung(M1,M2,S) :-
	setof(X,(member(X, M1); member(X, M2)), S).

% vereinigung([1,2,3,4,5],[3,4,7,8],S).
% S = [1, 2, 3, 4, 5, 7, 8] ;

% PROZEDUR:		differenz(M1, M2, S)
% PARAMETER:	M1, M2, S sind Mengen
% BEDEUTUNG:	ist wahr wenn S die Differenzmenge von M1, M2 ist.
%				Alle (x element M1 | x nichtelement M2). 
differenz(M1,M2,S) :-
	setof(X,(member(X, M1), \+ member(X, M2)), S).         

% differenz([1,2,3,4,5],[3,4,7,8],S).
% S = [1, 2, 5]

% PROZEDUR:		potenzmenge(M, P)
% PARAMETER:	M, P sind Mengen
% BEDEUTUNG:	ist wahr wenn P die Potenzmenge von M ist.
potenzmenge(M, P) :-
	pot_rec(M, [[]], PotMenge),
	menge(PotMenge,P).

	
% PROZEDUR:		pot_rec(M, Akk, Ergebnis)
% PARAMETER:	M, Akk, Ergebnis sind Mengen
% BEDEUTUNG:	ist wahr wenn Ergebnis die Potenzmenge von M ist.
pot_rec([],Akk,Akk).
pot_rec([Kopf|Rest], Akk, Ergebnis) :-
	findall(NS,(member(X,Akk), 
				append(X,[Kopf],NL), 
				menge(NL,NS)
			 ), Akkneu),
	append(Akkneu, Akk, Akkneu2),
	pot_rec(Rest, Akkneu2, Ergebnis).
	
	
% PROZEDUR:		cart_prod(M1, M2, P)
% PARAMETER:	M1, M2, P sind Mengen
% BEDEUTUNG:	ist wahr wenn P das kartesische Produkt von M1, M2 ist.
cart_prod(M1, M2, P) :-
	bagof(X:Y, (member(X,M1), member(Y,M2)), P).
